(*********************************************************************)
(*                         Diy                                       *)
(*                                                                   *)
(*   Jade Alglave, Luc Maranget INRIA Paris-Rocquencourt, France.    *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique. All rights reserved. This file is distributed    *)
(*  under the terms of the Lesser GNU General Public License.        *)
(*********************************************************************)

module Make(V:Constant.S) =
struct
  include X86Base
  module V = V

  type fence = MFence

  let strong = MFence

  let pp_fence = function
    | MFence -> "MFence"

  let sig_of_fence = function
    | MFence -> 'M'

  let fold_fences f r = f MFence r

  let orders f d1 d2 = match f,d1,d2 with
  | MFence,_,_ -> true

  include
      ArchExtra.Make
      (struct
        type arch_reg = reg
        let pp_reg = pp_reg
        let free_registers = allowed_for_symb
      end)
end
