(*********************************************************************)
(*                         Diy                                       *)
(*                                                                   *)
(*   Jade Alglave, Luc Maranget INRIA Paris-Rocquencourt, France.    *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique. All rights reserved. This file is distributed    *)
(*  under the terms of the Lesser GNU General Public License.        *)
(*********************************************************************)

module type S = sig
  include CompileCommon.S

  val emit_load : A.st -> Code.proc -> A.init -> Code.loc ->
    A.reg * A.init * A.pseudo list * A.st

  val emit_access : A.st -> Code.proc -> A.init -> C.event ->
    A.reg option * A.init * A.pseudo list * A.st

  val emit_access_dep :
      A.st -> Code.proc -> A.init -> C.event ->
        A.reg -> A.reg option * A.init * A.pseudo list * A.st

  val emit_access_ctrl :
      A.st -> Code.proc -> A.init -> C.event ->
        A.reg -> A.reg option * A.init * A.pseudo list * A.st

  val emit_fence : A.fence -> A.pseudo

end
