(*********************************************************************)
(*                          Litmus                                   *)
(*                                                                   *)
(*        Luc Maranget, INRIA Paris-Rocquencourt, France.            *)
(*        Susmit Sarkar, University of Cambridge, UK.                *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique and the authors. All rights reserved.             *)
(*  This file is distributed  under the terms of the Lesser GNU      *)
(*  General Public License.                                          *)
(*********************************************************************)

(* Copy [C source] files from litmus own files *)


module Make(A:Arch.S) =
  struct

    let actual_name name ext =
      if Globals.is_cross () then Tar.outname (name ^ ext)
      else MyName.outname name ext

    let cpy fnames name ext =
      let _,in_chan = MyName.open_lib ("_" ^ name ^ ext) in
      let fnames =
        begin try
          let fname = actual_name name ext in
          Misc.output_protect
            (fun chan ->
              MySys.cat_chan in_chan
                (fun line -> MySys.output_line chan line))
            fname ;
          fname::fnames
        with e -> close_in in_chan  ; raise e end in
      close_in in_chan ;
      fnames


    let dump () =
      let fnames = cpy [] "utils" ".c" in
      let fnames = cpy fnames "utils" ".h" in
      let fnames = cpy fnames "outs" ".c" in
      let fnames = cpy fnames "outs" ".h" in
      fnames
  end
