(*********************************************************************)
(*                          Litmus                                   *)
(*                                                                   *)
(*        Luc Maranget, INRIA Paris-Rocquencourt, France.            *)
(*        Susmit Sarkar, University of Cambridge, UK.                *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique and the authors. All rights reserved.             *)
(*  This file is distributed  under the terms of the Lesser GNU      *)
(*  General Public License.                                          *)
(*********************************************************************)

open Printf

let tmp_dir = ref None

let get_dir () = match !tmp_dir with
| None -> 
    let name = Filename.temp_file  "dir" ".tmp" in
    tmp_dir := Some name ;
    MySys.mkdir name ;
    name
| Some dir -> dir

let outname name = Filename.concat (get_dir ()) name

let tar archive =
  let dir = get_dir () in
  MySys.exec_stdout
    (sprintf "( cd %s && tar cf - . ) > %s && /bin/rm -rf %s"
      dir archive dir)
